﻿# http://dougfinke.com/blog/more-data-wrangling-with-powershell/
# Code by Doug Finke:

$template=@'
{Name*:George Washington}, {[int]TermStart:1789}-{[int]TermEnd:1797}
{Name*:William Henry Harrison}, {TermStart:1841} 
'@

((Invoke-WebRequest "http://www.ipl.org/div/potus/").AllElements | 
    Where {$_.class -eq 'potus75Width'}).outertext | 
    ConvertFrom-String -TemplateContent $template |
    foreach {
        $_ | Add-Member -PassThru -MemberType ScriptProperty -Name TotalYears `
            -Value {
                if($this.TermEnd) {
                    $this.TermEnd-$this.TermStart
                }
            }
    }
