﻿<#

SRIPTING GUYs articles on PS5 classes and enums

Introduction to PowerShell 5 Classes
http://blogs.technet.com/b/heyscriptingguy/archive/2015/08/31/introduction-to-powershell-5-classes.aspx

PowerShell 5: Create Simple Class
http://blogs.technet.com/b/heyscriptingguy/archive/2015/09/01/powershell-5-create-simple-class.aspx

Adding Enums to PowerShell 5 Classes
http://blogs.technet.com/b/heyscriptingguy/archive/2015/09/02/adding-enums-to-powershell-5-classes.aspx

New PowerShell 5 Feature: Enumerations
http://blogs.technet.com/b/heyscriptingguy/archive/2015/08/26/new-powershell-5-feature-enumerations.aspx

Working with Enums in PowerShell 5
http://blogs.technet.com/b/heyscriptingguy/archive/2015/08/27/working-with-enums-in-powershell-5.aspx

Use Inheritance in PowerShell 5 Classes
http://blogs.technet.com/b/heyscriptingguy/archive/2015/09/10/use-inheritance-in-powershell-5-classes.aspx

MORE:
http://blogs.technet.com/b/heyscriptingguy/archive/tags/classes/

#>

# Enumerations
Enum Vendor
{
  HP = 1
  Dell = 2
  IBM = 3
  Lenovo = 4  
}

# Class: The "blueprint"
Class Server  
 {
  [string]$Computername
  [vendor]$Vendor
  [string]$Model
 }

# Inheritance
Class HostedServer:Server
{
  [int64]$Contract
}

# Create Object
New-Object -TypeName Server
New-Object -TypeName HostedServer

[Server]::new()
[HostedServer]::new()

$www1 = [Server]::new()
$www1.Computername = 'www1'
$www1.Vendor = 'HP'
$www1.Model = '0815'

$www1 | Format-List

# Benchmarking
(Measure-Command {foreach ($i in 1..10000) { New-Object -TypeName Server }}).TotalMilliseconds
(Measure-Command {foreach ($i in 1..10000) { [Server]::new() }}).TotalMilliseconds