﻿<#
  FlashExtract 
  http://research.microsoft.com/en-us/um/people/sumitg/flashextract.html

  Powershell Team: ConvertFrom-String: Example-based text parsing
  http://blogs.msdn.com/b/powershell/archive/2014/10/31/convertfrom-string-example-based-text-parsing.aspx 
  
  Bartek Bielawski: Using the ConvertFrom-String cmdlet to parse structured text
  http://www.powershellmagazine.com/2014/09/09/using-the-convertfrom-string-cmdlet-to-parse-structured-text/
#>


# Part 1: The data
$champions2014 = @'
1
Manuel Neuer
Torwart
München

22
Roman Weidenfeller
Torwart
Dortmund

12
Ron-Robert Zieler
Torwart
Hannover

20
Jerome Boateng
Abwehr
München

15
Erik Durm
Abwehr
Dortmund

3
Matthias Ginter
Abwehr
Freiburg

2
Kevin Großkreutz
Abwehr
Dortmund

4
Benedikt Höwedes
Abwehr
Gelsenkirchen

5
Mats Hummels
Abwehr
Dortmund

17
Per Mertesacker
Abwehr
London

21
Shkodran Mustafi
Abwehr
Genua

14
Julian Draxler
Mittelfeld
Gelsenkirchen

6
Sami Khedira
Mittelfeld
Madrid

23
Christoph Kramer
Mittelfeld
Möchengladbach

18
Toni Kroos
Mittelfeld
München

16
Philipp Lahm
Mittelfeld
München

8
Mesut Özil
Mittelfeld
London

7
Bastian Schweinsteiger
Mittelfeld
München

19
Mario Götze
Angriff
München

11
Miroslav Klose
Angriff
Rom

13
Thomas Müller
Angriff
München

10
Lukas Podolski
Angriff
London

9
Andre Schürrle
Angriff
London
'@

# Part 2: The structure
$template = @'
{[int]id*:1}
{name:Manuel Neuer}
{position:Torwart}
{city:München}

{id*:22}
{name:Roman Weidenfeller}
{position:Torwart}
{city:Dortmund}
'@

$champions2014 | ConvertFrom-String -TemplateContent $template 

# Mind the [int] before the property id
$champions2014 | ConvertFrom-String -TemplateContent $template | Sort-Object -Property id

# File import
$file1 = 'C:\demo2\nationalelf.txt'
$file2 = 'C:\demo2\nationalelftemplate.txt'
Get-Content -Path $file1 | ConvertFrom-String -TemplateFile $file2 | Sort-Object -Property id