﻿#region DATA TYPES

# A simple string
[string]$computername = 'sea-dc1'

# A simple bool
[bool]$icmpEchoTest = $false 

# Whats an Object? 
$time1 = New-Object -TypeName DateTime 
$time2 = Get-Date

#endregion

#region BASIC TESTS

[bool]$icmpEchoTest = Test-Connection -ComputerName $computername -Count 1 -Quiet
[bool]$rdpTest = Test-NetConnection -ComputerName $computername -CommonTCPPort RDP -InformationLevel Quiet -WarningAction SilentlyContinue
if (Test-WSMan -ComputerName $computername -ErrorAction SilentlyContinue){[bool]$wsmanTest = $true} else {[bool]$wsmanTest = $false}

#endregion 

#region RESULTS_AS_HASHTABLE

$results = @{
 'computername' = $computername
 'ping' = $icmpEchoTest
 'rdp' = $rdpTest 
 'wsman' = $wsmanTest
}

$results
$results | Format-List
$results.ping

#endregion

#region PSOBJECT (sinve PoSh v1)  

$computerStatus = New-Object -TypeName psobject  -Property 
$computerStatus | Add-Member -MemberType NoteProperty -Name 'Computername' -Value $computername
$computerStatus | Add-Member -MemberType NoteProperty -Name 'ping'-Value  $icmpEchoTest
$computerStatus | Add-Member -MemberType NoteProperty -Name 'rdp' -Value $rdpTest
$computerStatus | Add-Member -MemberType NoteProperty -Name 'wsman' -Value $wsmanTest

$computerStatus.ping

#endregion

#region TYPEACCELERATOR (since PoSh v3)

 $computerStatus = [PSCustomObject]@{
    'Computername' = $computername
    'ping' = $icmpEchoTest
    'rdp' = $rdpTest
    'wsman' = $wsmanTest
 }

 $computerStatus
 $computerStatus | Format-List
 $computerStatus.ping

 #endregion

#region FORMATTING 

# Nice formattting
$computerStatus| Format-Table -Property Computername, 
    @{ Name='Ping' ; Expression={if ($_.ping)  {'x'} else {'-'}} },
    @{ Name='RDP'  ; Expression={if ($_.rdp)   {'x'} else {'-'}} },
    @{ Name='WSMan'; Expression={if ($_.wsman) {'x'} else {'-'}} }

#endregion